<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Scopes/Synopsis/SymbolLookup/Walker.html -->
<!-- this view was generated by Scope -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis::SymbolLookup::Walker</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Scope">
<div class="navigation">
<span class="normal"><a href="../../global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
<!-- this part was generated by Heading -->
<div class="class-module">namespace <a href="../../Synopsis.html" >Synopsis</a>::<a href="../SymbolLookup.html" >SymbolLookup</a>
</div><div class="class-name">class Walker

</div><div class="links"><div class="file">File: <a href="../../../File/Synopsis/SymbolLookup/Walker.hh.html" target="detail">../Synopsis/SymbolLookup/Walker.hh</a></div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line22" ><img src="../../../src-c++.png" alt="source code"/></a></div></div>  <img alt="Walker-inheritance" src="Walker-inheritance.png" hspace="8" vspace="8" border="0" usemap="#Walker-inheritance_map" />
<map name="Walker-inheritance_map"><area alt="Scopes/Synopsis/PTree/Visitor.html" href="../PTree/Visitor.html" shape="rect" coords="32, 7, 189, 31" />
</map>
 <div class="doc"><p>This Walker adjusts the symbol lookup table while the parse tree
is being traversed such that symbols in the parse tree can be
looked up correctly in the right context.</p>
</div>
<!-- this part was generated by Summary -->
<div class="summary">
<div class="heading">Public Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <a class="name" id="Walker_lScope_S_r">Walker</a>(<a href="Scope.html" >Scope</a>*)  </div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker_mWalker_lScope_S_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line25" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;<i>destructor</i> <a class="name" id="_tWalker_l_r">~Walker</a>()  </div> <div class="xref"><a href="../../../XRef/xref27.html#Synopsis_mSymbolLookup_mWalker_m_tWalker_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line26" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mList_S_r">visit</a>(<a href="../PTree/List.html" >PTree::List</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line29" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mBlock_S_r">visit</a>(<a href="../PTree/Block.html" >PTree::Block</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line30" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mTemplateDecl_S_r">visit</a>(<a href="../PTree/TemplateDecl.html" >PTree::TemplateDecl</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line31" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mNamespaceSpec_S_r">visit</a>(<a href="../PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line32" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mFunctionDefinition_S_r">visit</a>(<a href="../PTree/FunctionDefinition.html" >PTree::FunctionDefinition</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line33" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mClassSpec_S_r">visit</a>(<a href="../PTree/ClassSpec.html" >PTree::ClassSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line34" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mDotMemberExpr_S_r">visit</a>(<a href="../PTree/DotMemberExpr.html" >PTree::DotMemberExpr</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line35" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="visit_lPTree_mArrowMemberExpr_S_r">visit</a>(<a href="../PTree/ArrowMemberExpr.html" >PTree::ArrowMemberExpr</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line36" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Walker.html#traverse_body_lPTree_mNamespaceSpec_S_r" >traverse_body</a></span>(<a href="../PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line39" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the body of a namespace definition.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Walker.html#traverse_body_lPTree_mClassSpec_S_r" >traverse_body</a></span>(<a href="../PTree/ClassSpec.html" >PTree::ClassSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line41" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the body of the class definition.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Walker.html#traverse_parameters_lPTree_mTemplateDecl_S_r" >traverse_parameters</a></span>(<a href="../PTree/TemplateDecl.html" >PTree::TemplateDecl</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line43" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the template parameter list of a template declaration.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Walker.html#traverse_body_lPTree_mFunctionDefinition_S_r" >traverse_body</a></span>(<a href="../PTree/FunctionDefinition.html" >PTree::FunctionDefinition</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line45" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the body of the function definition.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Protected Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;const&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="current_scope_l_r">current_scope</a>()  </div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker_mcurrent_scope_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line48" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="leave_scope_l_r">leave_scope</a>()  </div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker_mleave_scope_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line49" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Typedefs Summary:</div>
<div class="item"><div class="synopsis">std::stack&lt;<a href="Scope.html" >Scope</a>*&gt; <a class="name" id="Scopes">Scopes</a></div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker_mScopes" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line51" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Walker.html#visit_block_lPTree_mBlock_S_r" >visit_block</a></span>(<a href="../PTree/Block.html" >PTree::Block</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line56" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>the virtual visit(Block) version above does scoping,
which isn't what we want if traversing a function (FIXME: or is it ?)
so the following factors out the common code.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Data members Summary:</div>
<div class="item"><div class="synopsis"><a href="Walker.html#Scopes" >Scopes</a> <span class="name"><a href="Walker.html#my_scopes" >my_scopes</a></span></div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker_mmy_scopes" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line58" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>The symbol lookup table.</p>
</div></div>
</div><!-- summary -->
<!-- this part was generated by Inheritance -->
<!-- this part was generated by Detail -->
<div class="detail">
<div class="heading">Public Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="traverse_body_lPTree_mNamespaceSpec_S_r">traverse_body</a>(<a href="../PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line39" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the body of a namespace definition.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="traverse_body_lPTree_mClassSpec_S_r">traverse_body</a>(<a href="../PTree/ClassSpec.html" >PTree::ClassSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line41" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the body of the class definition.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="traverse_parameters_lPTree_mTemplateDecl_S_r">traverse_parameters</a>(<a href="../PTree/TemplateDecl.html" >PTree::TemplateDecl</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line43" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the template parameter list of a template declaration.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="traverse_body_lPTree_mFunctionDefinition_S_r">traverse_body</a>(<a href="../PTree/FunctionDefinition.html" >PTree::FunctionDefinition</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line45" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Traverse the body of the function definition.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="visit_block_lPTree_mBlock_S_r">visit_block</a>(<a href="../PTree/Block.html" >PTree::Block</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line56" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>the virtual visit(Block) version above does scoping,
which isn't what we want if traversing a function (FIXME: or is it ?)
so the following factors out the common code.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Data members Details:</div>
<div class="item"><div class="synopsis"><a href="Walker.html#Scopes" >Scopes</a> <a class="name" id="my_scopes">my_scopes</a></div> <div class="xref"><a href="../../../XRef/xref26.html#Synopsis_mSymbolLookup_mWalker_mmy_scopes" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Walker.hh.html#line58" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>The symbol lookup table.</p>
</div></div>
</div><!-- detail -->

<div class="logo">Generated on Thu Apr 16 16:28:00 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
